/*
    Classe CCartesian
*/

#include "CCartesian.h"

CCartesian::CCartesian() {
   setscale(1, 1);
}

void CCartesian::setmax(float x, float y) {
     maxx = x; maxy = y;
     scalex = (x*2)/g.width();
     scaley = (y*2)/g.height();
}
     
void CCartesian::setscale(float x, float y) {
     scalex = x; scaley = y;
     maxx = (x*g.width())/2;
     maxy = (y*g.height())/2;
}

void CCartesian::plot(bool lined) {
   int h = g.height(), w = g.width();
   CCoord *c;
   float x, y;
   bool start = true;
   
   g.clear();
   g.line(w>>1, 0, w>>1, h, COLOR_WHITE);
   g.line(0, h>>1, w, h>>1, COLOR_WHITE);
   
   c = points.first();
   while(c) {
      x = (c->x + maxx) * scalex;
      y = (c->y + maxy) * scaley;
      if(lined) {
          if(start) {
              g.gotoxy((int) x, (int) y);
              start = false;
          } else g.lineto((int) x, (int) y, COLOR_WHITE);
      } else g.point((int) x, (int) y, COLOR_WHITE);
      c = points.next();
   }
}

void CCartesian::load(CPoints *p) {
     CCoord *c;
     points.clear();
     c = p->first();
     while(c) {
         points.add(c->x, c->y, c->z);
         c = p->next();
     }
}
