/*
    Classe CGraph
    draw lines and circles on your console screen
    link with GDI32.lib or with Dev-C++ link libgdi32.a via
    Project>>Project Options>>Parameters>>Add Lib>>libgdi32.a
    this is a Windows Console Application  
*/

#include "CGraph.h"

using namespace std; 

CGraph::CGraph() {  
    hConWnd = GetConsoleWndHandle();  
    lx = 0;
    ly = 0;
}  

int CGraph::BCX_Line (HWND Wnd,int x1,int y1,int x2,int y2,int Pen,HDC DrawHDC) {  
    int a,b=0;  
    HPEN hOPen;     // penstyle, width, color  
    HPEN hNPen = CreatePen(PS_SOLID, 2, Pen);  
    if (!DrawHDC) {
       DrawHDC = GetDC(Wnd); b = 1;  
    }
    hOPen = (HPEN)SelectObject(DrawHDC, hNPen);  
    // starting point of line  
    MoveToEx(DrawHDC, x1, y1, NULL);  
    // ending point of line  
    a = LineTo(DrawHDC, x2, y2);  
    DeleteObject(SelectObject(DrawHDC, hOPen));  
    if (b) 
       ReleaseDC(Wnd, DrawHDC);  
    return a;
}  

// converts circle(centerX,centerY,radius,pen) to WinApi function
// ellipse inside box with upper left and lower right coordinates
int CGraph::BCX_Circle(HWND Wnd,int X,int Y,int R,int Pen,int Fill,HDC DrawHDC) {
    int a, b = 0;  
    if (!DrawHDC) {
       DrawHDC = GetDC(Wnd);
       b = 1;
    }  // penstyle, width, color  
    HPEN   hNPen = CreatePen(PS_SOLID, 2, Pen);  
    HPEN   hOPen = (HPEN)SelectObject(DrawHDC, hNPen);  
    HBRUSH hOldBrush;  
    HBRUSH hNewBrush;  
    // if true will fill circle with pencolor  
    if (Fill)  {    
        hNewBrush = CreateSolidBrush(Pen);    
        hOldBrush = (HBRUSH)SelectObject(DrawHDC, hNewBrush);  
    }  else  {    
        hNewBrush = (HBRUSH)GetStockObject(NULL_BRUSH);    
        hOldBrush = (HBRUSH)SelectObject(DrawHDC, hNewBrush);  
    }  
    a = Ellipse(DrawHDC, X-R, Y+R, X+R, Y-R);  
    DeleteObject(SelectObject(DrawHDC, hOPen));  
    DeleteObject(SelectObject(DrawHDC, hOldBrush));  
    if (b) 
       ReleaseDC(Wnd, DrawHDC);  
    return a;
}  

// the hoop ...
HWND CGraph::GetConsoleWndHandle(void) {  
     HWND hConWnd;  
     OSVERSIONINFO os;  
     char szTempTitle[64], szClassName[128], szOriginalTitle[1024];   
     os.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );  
     GetVersionEx( &os );  
     // may not work on WIN9x  
     if ( os.dwPlatformId == VER_PLATFORM_WIN32s ) 
        return 0;   
     GetConsoleTitle( szOriginalTitle, sizeof( szOriginalTitle ) );  
     sprintf( szTempTitle,"%u - %u", GetTickCount(), GetCurrentProcessId() );  
     SetConsoleTitle( szTempTitle );  
     Sleep( 40 );  
     // handle for NT  
     hConWnd = FindWindow( NULL, szTempTitle );  
     SetConsoleTitle( szOriginalTitle );   
     // may not work on WIN9x  
     if ( os.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )  {    
          hConWnd = GetWindow( hConWnd, GW_CHILD );    
          if ( hConWnd == NULL )  
             return 0;    
          GetClassName( hConWnd, szClassName, sizeof ( szClassName ) );    
          while ( strcmp( szClassName, "ttyGrab" ) != 0 )    {      
                hConWnd = GetNextWindow( hConWnd, GW_HWNDNEXT );      
                if ( hConWnd == NULL )  
                   return 0;      
                GetClassName( hConWnd, szClassName, sizeof( szClassName ) );    
          } 
     }  
     return hConWnd;
}

void CGraph::point(int x, int y, int forecolor) {
     BCX_Line(hConWnd,x,y,x,y,forecolor,0);
}
     
void CGraph::line(int x1, int y1, int x2, int y2, int forecolor) {
     BCX_Line(hConWnd,x1,y1,x2,y2,forecolor,0);
}

void CGraph::circle(int x, int y, int r, int forecolor, int backcolor) {
     BCX_Circle(hConWnd,x,y,r,forecolor,backcolor,0);
}

void CGraph::gotoxy(int x, int y) {
     lx = x;
     ly = y;
}

void CGraph::lineto(int x, int y, int forecolor) {
     line(lx, ly, x, y, forecolor);
     lx = x;
     ly = y;
}

void CGraph::clear(int backcolor) {
    system("CLS");
}

int CGraph::width() {
    return 500;
}

int CGraph::height() {
    return 400;
}

