/*
    Header da classe CGraph
    
    link with GDI32.lib or with Dev-C++ link libgdi32.a via
    Project>>Project Options>>Parameters>>Add Lib>>libgdi32.a
*/

#ifndef _CGRAPH_
#define _CGRAPH_

    #include <windows.h>    // Win32API Header File
    #include <cstring>
    #include <cstdio> 

    #define COLOR_RED    RGB (255,0,0)
    #define COLOR_GREEN  RGB (0,255,0)
    #define COLOR_BLUE   RGB (0,0,255) 
    #define COLOR_WHITE  RGB (255, 255, 255)
    #define COLOR_BLACK  RGB (0, 0, 0)
    
    class CGraph {
          private:
                  HWND    hConWnd; 
                  
                  int lx, ly;
                  
                  int BCX_Line (HWND Wnd,int x1,int y1,int x2,int y2,int Pen,HDC DrawHDC);
                  int BCX_Circle(HWND Wnd,int X,int Y,int R,int Pen,int Fill,HDC DrawHDC);
                  HWND GetConsoleWndHandle(void);
          public:
                  CGraph();
                  
                  void clear(int backcolor=0);
                  void point(int x, int y, int forecolor);
                  void line(int x1, int y1, int x2, int y2, int forecolor);
                  void circle(int x, int y, int r, int forecolor, int backcolor);
                  
                  void gotoxy(int x, int y);
                  void lineto(int x, int y, int forecolor);
                  
                  int width();
                  int height();
    };
    
#endif
